export interface IProductModel {
    id: string;
    itemId: string;
    upc: string;
    name: string;
    price: number;
    quantity: number;
    qty: number;
    quantityOrder: number;
    image: string;
    unitOfMeasure: string;
    pricePer: number;
    promoDescription: string;
    description: string;
    salesRank: number;
    aisleId: string;
    departmentName: string;
    aisleName: string;
    shelfName: string;
    showStrikeThrough: Boolean;
    offerText: string;
    promoDescriptionVal: string;
    comment: string;
    comments: string;
    substitutionValue: string;
    substitutionPreference: string;
    promoType: string;
    promoTitle: string;
    basePrice: number;
    restrictedValue: number;
}
export interface ICouponModel {
    id: string;
    offerId: string;
    name: string;
    price: number;
    image: string;
    description: string;
    expiryDate: string;
    brand: string;
    category: string;
    offerPrice: string;
    status: string;
    offerType: string;
    refineBrand: string;
    refineDescription: string;
    refineOfferPrice: string;
    regularPrice: string;
    usageTypeTxt: string;
    usageType: string;
    offerPgmLabel: string;
    imageId: string;
    couponID: string;
    summary?: string;
}
export interface IDealModel {
    id: string;
    title: string;
    description: string;
    promo: string;
    image: string;
    expiryDate: string;
    brand: string;
    category: string;
    status: string;
}
export declare class DealModel implements IDealModel {
    id: string;
    title: string;
    description: string;
    promo: string;
    image: string;
    expiryDate: string;
    brand: string;
    category: string;
    status: string;
    constructor(data?: any);
}
export interface IDealUpdateModel {
    id: string;
    title: string;
    description: string;
    promo: string;
}
export declare class DealUpdateModel implements IDealUpdateModel {
    id: string;
    title: string;
    description: string;
    promo: string;
    constructor(data?: any);
}
export declare class CouponModel implements ICouponModel {
    id: string;
    offerId: string;
    name: string;
    price: number;
    image: string;
    description: string;
    expiryDate: string;
    updBtnText: string;
    updBtnMode: Boolean;
    brand: string;
    category: string;
    offerPrice: string;
    status: string;
    deleted: boolean;
    offerType: string;
    offerTs: string;
    endDate: string;
    offerPgm: string;
    refineBrand: string;
    refineDescription: string;
    refineOfferPrice: string;
    regularPrice: string;
    usageTypeTxt: string;
    usageType: string;
    offerPgmLabel: string;
    imageId: string;
    couponID: string;
    summary?: string;
    constructor(data?: any);
}
export interface ICouponUpdateModel {
    id: string;
    price: number;
    offerId: string;
    offerPrice: string;
}
export declare class CouponUpdateModel implements ICouponUpdateModel {
    id: string;
    price: number;
    offerId: string;
    offerPrice: string;
    constructor(data?: any);
}
export declare class ProductModel implements IProductModel {
    id: string;
    itemId: string;
    upc: string;
    name: string;
    price: number;
    quantity: number;
    qty: number;
    quantityOrder: number;
    image: string;
    unitOfMeasure: string;
    pricePer: number;
    promoDescription: string;
    description: string;
    salesRank: number;
    aisleId: string;
    departmentName: string;
    aisleName: string;
    shelfName: string;
    updBtnText: string;
    updBtnMode: Boolean;
    showStrikeThrough: Boolean;
    offerText: string;
    promoDescriptionVal: string;
    comment: string;
    comments: string;
    substitutionValue: string;
    substitutionPreference: string;
    promoType: string;
    promoTitle: string;
    basePrice: number;
    restrictedValue: number;
    constructor(data?: any);
}
export interface IProductUpdateModel {
    id: string;
    price: number;
    comment: string;
    substitutionValue: string;
    quantity: number;
}
export declare class ProductUpdateModel implements IProductUpdateModel {
    id: string;
    price: number;
    comment: string;
    substitutionValue: string;
    quantity: number;
    constructor(data?: any);
}
export interface IFilter {
    id: string;
    label: any;
}
export declare class FilterModel implements IFilter {
    id: string;
    label: any;
    constructor(data?: any);
}
export interface ISortRule {
    field: string;
    direction: number;
    type: string;
    callback?: (a: ProductModel, s: SortModel) => void;
}
export interface ISort {
    field: string;
    rule: ISortRule[];
    label: any;
    selected?: Boolean;
}
export declare class SortModel implements ISort {
    field: string;
    label: any;
    rule: ISortRule[];
    selected?: Boolean;
    constructor(data?: any);
}
export declare class DepartmentModel implements IFilter {
    id: string;
    label: any;
    aisle: string[];
    constructor(data?: any);
}
export declare class BrandModel implements IFilter {
    id: string;
    label: any;
    constructor(data?: any);
}
export interface LoaderState {
    show: boolean;
}
export interface ICarousel {
    type: String;
    behaviour: String;
    userRestrictions: String;
    dataSource: any;
    apiPostBody: any;
    actionButton: String;
}
export declare class CarouselModel implements ICarousel {
    type: String;
    behaviour: String;
    userRestrictions: String;
    dataSource: any;
    title: String;
    apiPostBody: any;
    actionButton: String;
    aisleName: String;
    constructor(data?: any);
}
export interface ICouponCarousel {
    carouselSource: String;
    carouselFilter: String;
    carouselOfferLimit: Number;
}
export declare class CouponCarouselModel implements ICouponCarousel {
    carouselSource: String;
    carouselFilter: String;
    carouselOfferLimit: number;
    errorMessage: string;
    carouselTitle: String;
    carouselLinkLabel: String;
    carouselLinkPath: String;
    upc: string;
    includePageName: String;
    odpOfferId: string;
    constructor(data?: any);
}
export interface IRewardsCarousel {
    errorMessage: string;
    title: string;
}
export declare class RewardsCarouselModel implements IRewardsCarousel {
    errorMessage: string;
    title: string;
    constructor(data?: any);
}
export interface IDealCarousel {
}
export declare class DealCarouselModel implements IDealCarousel {
    constructor(data?: any);
}
export interface IOfferDetail {
    offerId: string;
}
export declare class OfferDetail implements IOfferDetail {
    offerId: string;
    constructor(data?: any);
}
export interface IRewardDetail {
    rewardId: string;
}
export declare class RewardDetail implements IRewardDetail {
    rewardId: string;
    constructor(data?: any);
}
export interface IRewardModel {
    offerPrice: string;
    description: string;
    image: string;
    status: string;
    startDate: string;
    endDate: string;
    offerTs: string;
    usageType: string;
    offerPgm: string;
    purchaseInd: string;
    groceryRewardId: string;
    title: string;
    rewardsRequired: number;
    rewardsAvailable: number;
    generalDisclaimer: string;
    category: string;
    specialRank: number;
    displayStartDate: string;
    displayEndDate: string;
    detailPath: string;
}
export declare class RewardModel implements IRewardModel {
    offerPrice: string;
    description: string;
    image: string;
    status: string;
    startDate: string;
    endDate: string;
    offerTs: string;
    usageType: string;
    offerPgm: string;
    purchaseInd: string;
    groceryRewardId: string;
    title: string;
    rewardsRequired: number;
    rewardsAvailable: number;
    rewardsExpire: number;
    generalDisclaimer: string;
    category: string;
    specialRank: number;
    displayStartDate: string;
    displayEndDate: string;
    detailPath: string;
    constructor(data?: any);
}
