"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@angular/core");
// Services
var modal_service_1 = require("./modal.service");
var clip_service_1 = require("wcax-core-angular/clip.service");
function _window() {
    return window;
}
var ChildModalComponent = /** @class */ (function () {
    function ChildModalComponent(elementRef, _modalService, couponClipFn) {
        this.elementRef = elementRef;
        this._modalService = _modalService;
        this.couponClipFn = couponClipFn;
        this.modal = {
            title: "",
            titleBorder: false,
            id: "",
            modalClass: "",
            isRewardsSelected: false,
            isRewardsRedemption: false,
            //  isBoxtop: false,
            isServiceDetails: false,
            type: '',
            actionButton: '',
            reward: {},
            rewardId: '',
            displayRedemptionButton: true,
            titleId: "",
            describedId: ""
        };
        this.rewardsSelected = [];
    }
    ChildModalComponent.prototype.ngOnInit = function () {
        this.modal.type = this.type;
        this.modal.reward = this.reward;
        if (this.cancelRedemptionButton == true)
            this.modal.displayRedemptionButton = false;
        if (this.modal.type == "rewards-redemption") {
            //this.modal.title=`${ this.modal.reward.rewardsRequired } ${this.modal.reward.rewardsRequired == 1 ? "Reward" : "Rewards"} will be used for:`;
            this.modal.title = 'Confirm';
            this.modal.id = "rewards-redemption-confirmation-modal-" + this.modal.reward.groceryRewardId;
            this.modal.actionButton = "Use " + this.modal.reward.rewardsRequired + " " + (this.modal.reward.rewardsRequired == 1 ? "Reward" : "Rewards");
            this.modal.titleBorder = false;
            this.modal.isRewardsRedemption = true;
            this.modal.titleId = "rewards-redemption-title-id" + this.modal.reward.groceryRewardId;
            this.modal.describedId = "rewards-redemption-described-id" + this.modal.reward.groceryRewardId;
            this.modal.disableConfirmButtonID = '';
        }
    };
    ChildModalComponent.prototype.ngAfterViewInit = function () {
        // window['AB']['ARIA'].rewardsModalFocus(this.modal.id);
        var modalId = this.modal.id;
        var modalTitleId = this.modal.titleId;
        var check = false;
        var focusId = null;
        var rewards = [];
        var rewardIndex = 0;
        //rewards redemption modals
        if (this.modal.type == "rewards-redemption") {
            //on shown rewards redemption modal
            $("#" + this.modal.id).on('shown.bs.modal', function () {
                $("#" + modalId).attr('aria-hidden', 'false');
                //focus to modal header
                $("#" + modalTitleId).focus();
                //keep focus in modal when tabbing X icon
                $('.modal-refocus').on('keydown', function (e) {
                    //tab key is hit and X icon is focused
                    if ((e.which == 9) && $("this:focus")) {
                        //tab back
                        if (e.shiftKey == true) {
                            e.preventDefault();
                            $('.modal-refocus1').focus();
                        }
                        else if (e.shiftKey == false) {
                            e.preventDefault();
                            $('.modal-heading').focus();
                        }
                    }
                    console.log('modal-refocu key down');
                });
                //keep focus in modal when tabbing confirm btn
                $('.modal-refocus1').on('keydown', function (e) {
                    //tab key is hit and confirm button is focused
                    if ((e.which == 9) && $("this:focus")) {
                        if (e.shiftKey == false) {
                            e.preventDefault();
                            $('.modal-close').focus();
                        }
                    }
                    console.log('modal-refocus1 key down');
                });
                //If cancel or x is hit, clear rewardFocus from localStorage//
                $('.modal-cancel, .modal-x').click(function () {
                    localStorage.setItem('rewardFocus', '');
                });
                //Get next focusable element//
                check = false;
                focusId = null;
                rewards = [];
                rewardIndex = 0;
                $('.reward-use-btn').each(function () {
                    rewards[rewardIndex] = $(this).data('focus');
                    rewardIndex++;
                    if (check == true && !focusId) {
                        focusId = $(this).data('focus');
                        localStorage.setItem("rewardFocus", focusId);
                    }
                    if ($(this).data('focus') == modalTitleId) {
                        check = true;
                    }
                });
                if (!focusId) {
                    localStorage.setItem("rewardFocus", rewards[rewardIndex - 2]);
                }
            });
            $("#" + this.modal.id).on('hidden.bs.modal', function () {
                $("#" + modalId).attr('aria-hidden', 'true');
            });
        }
    };
    ChildModalComponent.prototype.clipReward = function () {
        this.modal.reward.isConfirmModalButtonDisabled = true;
        this.couponClipFn.clipReward(this.modal.reward, this.updateStatistics);
    };
    ChildModalComponent.prototype.updateStatistics = function () {
        // update analytics data layer
        window['AB']['DATALAYER'].pushEvent({ name: 'coupon_clipped' });
        if (localStorage.getItem('abCoupons')) {
            var allCoupons = JSON.parse(localStorage.getItem('abCoupons'));
            for (var offerId in allCoupons.offers) {
                var coupon = allCoupons.offers[offerId];
                if (coupon.offerTs == this.reward.offerTs) {
                    var couponInfo = {
                        brand: coupon.brand,
                        offerType: coupon.offerPgm,
                        offerId: coupon.offerId,
                        offerPrice: coupon.offerPrice,
                        carouselSection: this.reward.rewardsRequired + " Rewards"
                    };
                    window['AB']['DATALAYER'].clipCoupon(couponInfo);
                }
            }
        }
    };
    //Not used but have to be declared because they use the same html template
    ChildModalComponent.prototype.getSelectedRewards = function () {
        var _this = this;
        if (this._isRegistered() && this.modal.isRewardsRedemption) {
            //add class to active reward offer for ADA focus
            var activeId = this.modal.id;
            $('#' + activeId).closest('.reward-grid-itme').addClass('activeRewardsModal');
            this._modalService
                .getSelectedRewardsOffers()
                .subscribe(function (response) {
                _this.rewardsSelected = response;
            });
        }
    };
    ChildModalComponent.prototype._isRegistered = function () {
        return (window['AB']['COMMON'].sessionNotExpired() && window['AB']['COMMON'].authorizeJ4U());
    };
    tslib_1.__decorate([
        core_1.Input(),
        tslib_1.__metadata("design:type", Object)
    ], ChildModalComponent.prototype, "type", void 0);
    tslib_1.__decorate([
        core_1.Input(),
        tslib_1.__metadata("design:type", Object)
    ], ChildModalComponent.prototype, "reward", void 0);
    tslib_1.__decorate([
        core_1.Input(),
        tslib_1.__metadata("design:type", Object)
    ], ChildModalComponent.prototype, "cancelRedemptionButton", void 0);
    ChildModalComponent = tslib_1.__decorate([
        core_1.Component({
            selector: "child-modal",
            templateUrl: "./modal.component.html"
        }),
        core_1.Injectable(),
        tslib_1.__metadata("design:paramtypes", [core_1.ElementRef,
            modal_service_1.ModalService,
            clip_service_1.ClipService])
    ], ChildModalComponent);
    return ChildModalComponent;
}());
exports.ChildModalComponent = ChildModalComponent;
//# sourceMappingURL=child-modal.component.js.map