"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@angular/core");
// Services
var modal_service_1 = require("./modal.service");
var clip_service_1 = require("wcax-core-angular/clip.service");
function _window() {
    return window;
}
var ModalComponent = /** @class */ (function () {
    function ModalComponent(elementRef, _modalService, couponClipFn) {
        this.elementRef = elementRef;
        this._modalService = _modalService;
        this.couponClipFn = couponClipFn;
        this.modal = {
            title: "",
            titleBorder: false,
            id: "",
            modalClass: "",
            isRewardsSelected: false,
            isRewardsRedemption: false,
            isBoxtop: false,
            isServiceDetails: false,
            type: '',
            actionButton: '',
            reward: {},
            rewardId: '',
            displayRedemptionButton: false,
            titleId: ''
        };
        this.rewardsSelected = [];
    }
    ModalComponent.prototype.ngOnInit = function () {
        if (this.elementRef.nativeElement.getAttribute("data-modal-type"))
            this.modal.type = this.elementRef.nativeElement.getAttribute("data-modal-type");
        if (this.elementRef.nativeElement.getAttribute("data-modal-parent"))
            this.modal.parent = this.elementRef.nativeElement.getAttribute("data-modal-parent");
        if (this.elementRef.nativeElement.getAttribute("data-modal-reward-id"))
            this.modal.rewardId = this.elementRef.nativeElement.getAttribute("data-modal-reward-id");
        if (this.elementRef.nativeElement.getAttribute("data-modal-actionButton"))
            this.modal.actionButton = this.elementRef.nativeElement.getAttribute("data-modal-actionButton");
        if (this.elementRef.nativeElement.getAttribute("data-modal-displayRedemptionButton"))
            this.modal.displayRedemptionButton = this.elementRef.nativeElement.getAttribute("data-modal-displayRedemptionButton");
        if (this.modal.type == "rewards-selected") {
            this.modal.title = "My Selected Rewards:";
            this.modal.titleId = "rewards-selected-modal-title";
            this.modal.titleBorder = true;
            this.modal.id = "rewards-selected-modal";
            this.modal.describedId = this.modal.titleId;
            this.modal.isRewardsSelected = true;
        }
        else if (this.modal.type == "boxtop") {
            this.modal.title = "Get started today - enroll in Box Tops for Education";
            this.modal.titleBorder = false;
            this.modal.titleId = 'boxtopModalTitle';
            switch (this.modal.parent) {
                case "product-carousel":
                    this.modal.id = "boxtop-modal-pc";
                    break;
                case "coupon-carousel":
                    this.modal.id = "boxtop-modal-cc";
                    break;
                case "coupon-grid":
                    this.modal.id = "boxtop-modal-cg";
                    break;
                case "offer-details":
                    this.modal.id = "boxtop-modal-od";
                    break;
                default:
                    this.modal.id = "boxtop-modal";
            }
            this.modal.isBoxtop = true;
            this.modal.actionButton = "Boxtop modal";
            // Only call once on the page even if it is integrated into more components
            if (this._isRegistered() && (!window["AB"].userInfo.boxTopCalled)) {
                window["AB"].userInfo.boxTopCalled = true;
                //                 if (localStorage.getItem('loyaltyPartners')) {
                //                     const data = JSON.parse(localStorage.getItem('loyaltyPartners'));
                //                     if (data['loyaltyPartners']) {
                //                         data['loyaltyPartners'].forEach(function (loyaltyPartner) {
                //                             if ((loyaltyPartner) && (loyaltyPartner.name == "GeneralMills") && (loyaltyPartner.planNumber) && (loyaltyPartner.planNumber.length > 1)) {
                //                                 window["AB"].userInfo.boxTopAuth = true;
                //                             }
                //                         });
                //                     }
                //                 } else {
                //                     this.objBoxTop.getGeneralMillsId().subscribe(data => {
                //                         localStorage.setItem('loyaltyPartners', JSON.stringify(data));
                //                         if (data['loyaltyPartners']) {
                //                             data['loyaltyPartners'].forEach(function (loyaltyPartner) {
                //                                 if ((loyaltyPartner) && (loyaltyPartner.name == "GeneralMills") && (loyaltyPartner.planNumber) && (loyaltyPartner.planNumber.length > 1)) {
                //                                     window["AB"].userInfo.boxTopAuth = true;
                //                                 }
                //                             });
                //                         }
                //                     });
                //               }
            }
        }
        else if (this.modal.type == "service-details") {
            this.modal.id = "service-details";
            this.modal.titleId = "service-details-title";
            this.modal.actionButton = this.elementRef.nativeElement.getAttribute("data-modal-actionButton");
            this.modal.title = this.elementRef.nativeElement.getAttribute("data-modal-title");
            this.modal.leftsubtitle = this.elementRef.nativeElement.getAttribute("data-modal-leftsubtitle");
            this.modal.lefttext = this.elementRef.nativeElement.getAttribute("data-modal-lefttext");
            this.modal.rightsubtitle = this.elementRef.nativeElement.getAttribute("data-modal-rightsubtitle");
            this.modal.righttext = this.elementRef.nativeElement.getAttribute("data-modal-righttext");
            this.modal.rightlinktext = this.elementRef.nativeElement.getAttribute("data-modal-rightlinktext");
            this.modal.rightlink = this.elementRef.nativeElement.getAttribute("data-modal-rightlink");
            if (this.modal.actionButton != null)
                this.modal.isServiceDetails = true;
            else
                this.modal.isServiceDetails = false;
        }
    };
    ModalComponent.prototype.ngAfterViewInit = function () {
        // window['AB']['ARIA'].rewardsModalFocus(this.modal.id);
        _window()['AB']['ARIA'].init();
    };
    ModalComponent.prototype.clipReward = function () {
        this.couponClipFn.clipReward(this.modal.reward, this.updateStatistics);
        _window()['location']['href'] = _window()['location']['href'].split('justforu')[0] + 'justforu/rewards.html';
        // window['AB']['ARIA'].rewardsModalFocus(this.modal.id);
    };
    ModalComponent.prototype.updateStatistics = function () {
        // update analytics data layer
        window["AB"]["DATALAYER"].pushEvent({ name: "reward_clipped" });
        window["AB"]["DATALAYER"].clipCoupon(this.modal.reward);
    };
    ModalComponent.prototype.neverShowBoxtop = function () {
        localStorage.setItem("showBoxtop", 'false');
        this._modalService.cancelBoxtopDisplay();
    };
    ModalComponent.prototype.redirectToBoxtopPage = function () {
        localStorage.setItem('boxtopActionName', 'get_started');
        if (_window()['location']['href'].includes('justforu')) {
            _window()['location']['href'] = _window()['location']['href'].split('justforu')[0] + 'boxtops.html';
        }
        else {
            _window()['location']['href'] = _window()['location']['origin'] + '/boxtops.html';
        }
    };
    ModalComponent.prototype.getSelectedRewards = function () {
        var _this = this;
        if (this._isRegistered() && this.modal.isRewardsSelected) {
            this._modalService
                .getSelectedRewardsOffers()
                .subscribe(function (response) {
                _this.rewardsSelected = response;
            });
        }
    };
    ModalComponent.prototype._isRegistered = function () {
        return (window['AB']['COMMON'].sessionNotExpired() && window['AB']['COMMON'].authorizeJ4U());
    };
    ModalComponent = tslib_1.__decorate([
        core_1.Component({
            selector: "modal",
            templateUrl: "./modal.component.html"
        }),
        core_1.Injectable(),
        tslib_1.__metadata("design:paramtypes", [core_1.ElementRef,
            modal_service_1.ModalService,
            clip_service_1.ClipService])
    ], ModalComponent);
    return ModalComponent;
}());
exports.ModalComponent = ModalComponent;
//# sourceMappingURL=modal.component.js.map