"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
var Observable_1 = require("rxjs/Observable");
var BehaviorSubject_1 = require("rxjs/BehaviorSubject");
require("rxjs/add/observable/of");
var ModalService = /** @class */ (function () {
    function ModalService(_http) {
        this._http = _http;
        this.selectedRewardsOffers = new BehaviorSubject_1.BehaviorSubject([]);
        this.showBoxtop = new BehaviorSubject_1.BehaviorSubject(true);
        this.userEndpoint = "/bin/safeway/userinfo?banner=tomthumb";
    }
    ModalService.prototype.getSelectedRewardsOffers = function () {
        if (window["AB"]["COMMON"].authorizeJ4U()) {
            var httpOptions = { headers: new http_1.HttpHeaders(window['AB'].j4uHttpOptions) };
            return this._http
                .get(window["AB"]["selectedRewardsPath"] + "?storeId=" + window["AB"]["userInfo"]['j4u']["storeId"], httpOptions)
                .map(function (response) {
                response.myGroceryRewardsList.forEach(function (reward) {
                    reward['endDate'] = reward['endDate'].split('(')[1].split(')')[0];
                });
                return response.myGroceryRewardsList;
            });
        }
        else {
            return Observable_1.Observable.of();
        }
    };
    ModalService.prototype.cancelBoxtopDisplay = function () {
        this.showBoxtop.next(false);
    };
    ModalService = tslib_1.__decorate([
        core_1.Injectable(),
        tslib_1.__metadata("design:paramtypes", [http_1.HttpClient])
    ], ModalService);
    return ModalService;
}());
exports.ModalService = ModalService;
//# sourceMappingURL=modal.service.js.map