"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@angular/core");
var search_filter_service_1 = require("wcax-core-angular/search-filter.service");
var coupon_filter_service_1 = require("wcax-core-angular/coupon-filter.service");
var SearchComponent = /** @class */ (function () {
    function SearchComponent(_searchService, _couponFilterService) {
        var _this = this;
        this._searchService = _searchService;
        this._couponFilterService = _couponFilterService;
        this.currentSearch = '';
        this.queryParam = '';
        this.queryDelimiter = '&';
        this.showDropdownOnLoad = true;
        this.COMMON = window['AB']['COMMON'];
        /* Populate Category Filter Array */
        _searchService.currentSearch.subscribe(function (searchFilter) {
            _this.searchFilter = searchFilter;
        });
        _searchService.currentFilterSearch.subscribe(function (currentSearch) { return _this.currentSearch = currentSearch; });
        var search = window.location.search;
        console.log("Search Parameter: ", this.COMMON.getURLParameterByName('search'));
        if (this.COMMON.getURLParameterByName('search') != '') {
            search = this.COMMON.removeURLParameterByName(search, 'search');
            this.queryParam = '';
        }
        search = search.replace('?', '');
        this.queryParam = search;
        this.queryDelimiter = (this.queryParam != '') ? '&' : '';
        if (window.innerWidth < 768) {
            this.showDropdownOnLoad = false;
        }
    }
    SearchComponent.prototype.onKeyPress = function (strQueryParam, strQueryDelimiter, strFilterquery, event) {
        var url = '?' + strQueryParam + strQueryDelimiter + 'search=' + strFilterquery;
        if (strFilterquery == '' || strFilterquery == null) {
            window.location.search = this.COMMON.removeURLParameterByName(window.location.search, 'search');
            window.history.pushState({}, null, window.location.search);
        }
        else {
            window.history.pushState({}, null, url);
        }
        this._couponFilterService.applyFilter('search');
    };
    SearchComponent = tslib_1.__decorate([
        core_1.Component({
            selector: 'search-component',
            templateUrl: './search.component.html'
        }),
        core_1.Injectable(),
        tslib_1.__metadata("design:paramtypes", [search_filter_service_1.SearchFilterService, coupon_filter_service_1.CouponFilterService])
    ], SearchComponent);
    return SearchComponent;
}());
exports.SearchComponent = SearchComponent;
//# sourceMappingURL=search.component.js.map