"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/**
* Angular App Modules.
*
* @file Main Angular's application properties.
*/
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
var platform_browser_1 = require("@angular/platform-browser");
var forms_1 = require("@angular/forms");
var core_module_1 = require("wcax-core-angular/core.module");
/**
* Main Components.
*
* @description Components that should be boostraped directly in AEM page(s).
*/
var search_component_1 = require("./search/search.component");
var modal_component_1 = require("./modal/modal.component");
/**
* Children Components.
*
* @description Components that extends Main Components functionality and are not bootstrapped individually.
*/
var sort_component_1 = require("./sort/sort.component");
var loading_spinner_component_1 = require("./loading-spinner/loading-spinner.component");
var child_modal_component_1 = require("./modal/child-modal.component");
/**
* Main & Children components Services.
*
* @description Services that are used across Angular application.
*/
var sort_service_1 = require("./sort/sort.service");
var loading_spinner_service_1 = require("./loading-spinner/loading-spinner.service");
var modal_service_1 = require("./modal/modal.service");
// Angular's NgModule
var SharedModule = /** @class */ (function () {
    function SharedModule() {
    }
    SharedModule = tslib_1.__decorate([
        core_1.NgModule({
            declarations: [
                sort_component_1.SortComponent,
                loading_spinner_component_1.LoaderComponent,
                child_modal_component_1.ChildModalComponent,
                search_component_1.SearchComponent,
                modal_component_1.ModalComponent
            ],
            imports: [
                platform_browser_1.BrowserModule,
                http_1.HttpClientModule,
                forms_1.FormsModule,
                core_module_1.CoreModule
            ],
            providers: [
                sort_service_1.SortService,
                loading_spinner_service_1.LoaderService,
                modal_service_1.ModalService
            ],
            exports: [
                search_component_1.SearchComponent,
                modal_component_1.ModalComponent,
                loading_spinner_component_1.LoaderComponent,
                sort_component_1.SortComponent,
                child_modal_component_1.ChildModalComponent
            ]
        }),
        core_1.Injectable()
    ], SharedModule);
    return SharedModule;
}());
exports.SharedModule = SharedModule;
//# sourceMappingURL=shared.module.js.map