import { EventEmitter, OnChanges, SimpleChanges, AfterViewInit } from '@angular/core';
import { ElementRef, Renderer2 } from '@angular/core';
import { SortModel } from '../data.model';
export declare class SortComponent implements OnChanges, AfterViewInit {
    private rd;
    sortRules: SortModel[];
    activeSortRule: SortModel;
    activeSortRuleEmitter: EventEmitter<SortModel>;
    el: ElementRef;
    arriaExpanded: Boolean;
    selectedSortRuleIndex: Number;
    defaultSorted: Boolean;
    constructor(rd: Renderer2);
    doSortEmitter(activeSortRule: SortModel): void;
    /**
     * Triggered on properties changes - Search and update new active sort rule index
     *
     * @param {SimpleChanges} changes properties that has been changed
     */
    ngOnChanges(changes: SimpleChanges): void;
    /**
     * Call Accessibility ARIA methods
     */
    ngAfterViewInit(): void;
    sortByComponent: () => void;
}
