"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@angular/core");
var core_2 = require("@angular/core");
// Data Model
var data_model_1 = require("../data.model");
var SortComponent = /** @class */ (function () {
    function SortComponent(rd) {
        this.rd = rd;
        this.activeSortRuleEmitter = new core_1.EventEmitter();
        this.arriaExpanded = false;
        this.defaultSorted = false;
        /* Sort by, Angular dropdown component ARIA , Taken from ARIA.JS*/
        this.sortByComponent = function () {
            var sortBy = $(".dropdown-sort-by.dropdown");
            var sortByButton = sortBy.find('#sortByID');
            $(".sort-by-text").focusout(function () {
                $(this).css('outline', 'none');
            });
            /* aria-expanded removed when dropdown list is hidden + focus changing*/
            sortBy.on("hidden.bs.dropdown", function (e) {
                sortByButton.removeAttr('aria-expanded');
                e.preventDefault();
                setTimeout(function () {
                    $('body .sort-by-wrapper button#sortByID').focus();
                }, 300);
            });
            // to add the showPromo class for filters in mobile view
            if ($('div.cfh-banner.cfh-banner__search').length > 0) {
                $('#filterMV').addClass('showPromo');
            }
            $(document).not('.squaredThree').on('click', 'label', function (e) {
                $(this).css('outline', 'none');
            });
            $('.label-more').on('click', function (e) {
                $(this).prev().children(':eq(5)').children('label').css('outline', 'none'); //.css('outline','none')
                // $('#searchFilterBy' + id + ' .filter-wrapper div:nth-child(6) input').parent().css('outline','none')
            });
        };
    }
    SortComponent.prototype.doSortEmitter = function (activeSortRule) {
        this.activeSortRule = activeSortRule;
        this.activeSortRuleEmitter.emit(this.activeSortRule);
    };
    /**
     * Triggered on properties changes - Search and update new active sort rule index
     *
     * @param {SimpleChanges} changes properties that has been changed
     */
    SortComponent.prototype.ngOnChanges = function (changes) {
        var _this = this;
        if (changes.activeSortRule)
            this.sortRules.forEach(function (sort, i) {
                if (sort.field === _this.activeSortRule.field) {
                    _this.selectedSortRuleIndex = i;
                    sort.selected = true;
                    if (_this.defaultSorted)
                        window['AB']['DATALAYER'].sortBy(sort.label);
                    _this.defaultSorted = true;
                }
                else
                    sort.selected = null;
            });
    };
    /**
     * Call Accessibility ARIA methods
     */
    SortComponent.prototype.ngAfterViewInit = function () {
        this.sortByComponent();
        /* $(this.el.nativeElement).focus(); */
        this.el.nativeElement.style.background = "white";
        this.el.nativeElement.style.border = "0px solid";
        if (this.el.nativeElement == undefined) {
            console.log("sortID NO detected");
        }
        else {
            console.log("sortID YES detected");
        }
    };
    tslib_1.__decorate([
        core_1.Input(),
        tslib_1.__metadata("design:type", Array)
    ], SortComponent.prototype, "sortRules", void 0);
    tslib_1.__decorate([
        core_1.Input(),
        tslib_1.__metadata("design:type", data_model_1.SortModel)
    ], SortComponent.prototype, "activeSortRule", void 0);
    tslib_1.__decorate([
        core_1.Output(),
        tslib_1.__metadata("design:type", core_1.EventEmitter)
    ], SortComponent.prototype, "activeSortRuleEmitter", void 0);
    tslib_1.__decorate([
        core_1.ViewChild('sortId'),
        tslib_1.__metadata("design:type", core_2.ElementRef)
    ], SortComponent.prototype, "el", void 0);
    SortComponent = tslib_1.__decorate([
        core_1.Component({
            selector: 'sort-by',
            templateUrl: './sort.component.html'
        }),
        tslib_1.__metadata("design:paramtypes", [core_2.Renderer2])
    ], SortComponent);
    return SortComponent;
}());
exports.SortComponent = SortComponent;
//# sourceMappingURL=sort.component.js.map