import {Component, OnInit} from "@angular/core";
import {Subscription} from "rxjs/Subscription";
import {LoaderService} from "./loading-spinner.service";
import {LoaderState} from "../data.model";

@Component({
    selector: 'loading-spinner',
    templateUrl: 'loading-spinner.component.html'
})

export class LoaderComponent implements OnInit {
    public show = false;
    public clasicSpinnerImg = true;
    public modernSpinnerImg = !this.clasicSpinnerImg;
    private $subscription: Subscription;

    public constructor(private loaderService: LoaderService) { }

    ngOnInit() {
        this.$subscription = this.loaderService.loaderState.subscribe(
            (state: LoaderState) => this.show = state.show);
    }

    ngOnDestroy() {
        this.$subscription.unsubscribe();
    }
}
