import { Injectable } from "@angular/core";
import { HttpClient, HttpHeaders } from "@angular/common/http";
import { Observable } from "rxjs/Observable";
import { BehaviorSubject } from "rxjs/BehaviorSubject";
import "rxjs/add/observable/of";

// Data model
import { RewardModel } from "../data.model";

@Injectable()
export class ModalService {
    public selectedRewardsOffers = new BehaviorSubject<any[]>([]);
    public showBoxtop = new BehaviorSubject<boolean>(true);
    private userEndpoint: string = "/bin/safeway/userinfo?banner=tomthumb";

    public constructor(private _http: HttpClient) {}

    public getSelectedRewardsOffers(): Observable<RewardModel[]> {
        if(window["AB"]["COMMON"].authorizeJ4U()) {
            let httpOptions = { headers: new HttpHeaders(window['AB'].j4uHttpOptions) };
            return this._http
                .get(window["AB"]["selectedRewardsPath"] + "?storeId=" + window["AB"]["userInfo"]['j4u']["storeId"],httpOptions)
                .map((response: any) => {
                    response.myGroceryRewardsList.forEach(reward => {
                        reward['endDate'] = reward['endDate'].split('(')[1].split(')')[0];
                    });
                    return response.myGroceryRewardsList;
                });
        }else{
            return Observable.of();
        }

    }

    public cancelBoxtopDisplay(){
        this.showBoxtop.next(false);
    }
}
