import {Component, Injectable} from '@angular/core';
import {SearchFilterService} from "wcax-core-angular/search-filter.service";
import {CouponFilterService} from "wcax-core-angular/coupon-filter.service";

@Component({
    selector: 'search-component',
    templateUrl: './search.component.html'
})

@Injectable()
export class SearchComponent {

    public searchFilter: any;
    public currentSearch: String = '';
    public queryParam: any = '';
    public queryDelimiter = '&';
    public showDropdownOnLoad = true;
    public COMMON = window['AB']['COMMON'];

    public constructor(private _searchService: SearchFilterService, private _couponFilterService: CouponFilterService) {
        /* Populate Category Filter Array */
        _searchService.currentSearch.subscribe(searchFilter => {
            this.searchFilter = searchFilter;
        });

        _searchService.currentFilterSearch.subscribe(currentSearch => this.currentSearch = currentSearch);

        let search: any = window.location.search;
        console.log("Search Parameter: ", this.COMMON.getURLParameterByName('search'));
        if (this.COMMON.getURLParameterByName('search') != '') {
            search = this.COMMON.removeURLParameterByName(search, 'search');
            this.queryParam = '';
        }
        search = search.replace('?', '');
        this.queryParam = search;

        this.queryDelimiter = (this.queryParam != '') ? '&' : '';

        if (window.innerWidth < 768) {
            this.showDropdownOnLoad = false;
        }
    }

    public onKeyPress(strQueryParam: string, strQueryDelimiter: string, strFilterquery: string, event: any): void {
        const url = '?' + strQueryParam + strQueryDelimiter + 'search=' + strFilterquery;
        if (strFilterquery == '' || strFilterquery == null) {
            window.location.search = this.COMMON.removeURLParameterByName(window.location.search, 'search');
            window.history.pushState({}, null, window.location.search);
        }else{
            window.history.pushState({}, null, url);
        }
        this._couponFilterService.applyFilter('search');
    }
}
